/* (C) Copyright 1993 by Steven Trainoff.  Permission is granted to make
* any use of this code subject to the condition that all copies contain
* this notice and an indication of what has been changed.
*/
/* error.c - error handling stdio routines */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "spt.h"

char *progname = "error";

FILE *efopen(file, mode)
char *file;
char *mode;
{
	FILE *fp;

	if ((fp = fopen(file, mode)) != (FILE *)NULL)
		return(fp);

	fprintf(stderr, "%s: can't open file %s mode %s.\n", progname, file, mode);
	exit(ERROR);
	return((FILE *)NULL);	/* To keep the compiler happy */
}

void *emalloc(size)
unsigned size;
{
	void *storage;

	if ((storage = malloc(size)) != NULL)
		return(storage);

	fprintf(stderr, "%s: out of memory (requested %d bytes)\n", progname, size);
	exit(ERROR);
	return(NULL);		/* To keep the compiler happy */
}

void *ecalloc(size)
unsigned size;
{
	void *storage;

	if ((storage = calloc(1,size)) != NULL)
		return(storage);

	fprintf(stderr, "%s: out of memory (requested %d bytes)\n", progname, size);
	exit(ERROR);
	return(NULL);		/* To keep the compiler happy */
}


char *efgets(line, maxlen, infile)
char *line;
int maxlen;
FILE *infile;
{
	if (fgets(line, maxlen, infile) != NULL)
		return(line);

	fprintf(stderr, "%s: unexpected end of file\n", progname);
	exit(ERROR);
	return((char *)NULL);		/* To keep the compiler happy */
}


/* getint - get an integer with a default */
int getint(prompt, def)
char *prompt;		/* Prompt text */
int def;		/* Default if no input */
{
	char line[MAXLEN];	/* Input line */

	fprintf(stderr, "%s", prompt);
	fgets(line, MAXLEN, stdin);
	if (strlen(line) == 1)		/* Nothing inputed - use default */
		return(def);

	return(atoi(line));
}


/* getdbl - get a dbl with a default */
double getdbl(prompt, def)
char *prompt;		/* Prompt text */
double def;		/* Default if no input */
{
	char line[MAXLEN];	/* Input line */

	fprintf(stderr, "%s", prompt);
	fgets(line, MAXLEN, stdin);
	if (strlen(line) == 1)		/* Nothing inputed - use default */
		return(def);

	return(atof(line));
}

#if (1==2)

/* Zero a section of memory */
bzero(addr, len)
char *addr;	/* Initial address */
int len;	/* Number of bytes */
{
	while (len > 0) {
		*addr++= 0;
		len--;
	}
}

/* Copy a section of memory */
void bcopy(char * addr, char *dest, int len)
/* char *addr;  */ /* Source address */
/* char *dest; */	/* Destination address */
/* int len;	*/ /* Number of bytes */
{
	while (len > 0) {
		*dest = *addr;
		addr++;
		dest++;
		len--;
	}
}
#endif
