/* (C) Copyright 1993 by Steven Trainoff.  Permission is granted to make
* any use of this code subject to the condition that all copies contain
* this notice and an indication of what has been changed.
*/
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include "spt.h"

#ifndef REAL
#define REAL double		/* Precision of data */
#endif
#include "fft.h"

/* extern long rand();
extern int srand(); */

void main(argc, argv)
int argc;
char **argv;
{
	REAL (*data)[2];
	REAL (**array)[2];
	REAL (*copy_of_data)[2];
	REAL (**copy_of_array)[2];
	int i, j;
	int nu, n;
	double sum;
	int dim[2];

	if (argc < 2) {
		fprintf(stderr, "Usage %s nu\n", argv[0]);
		exit(-1);
	}
	nu = atoi(argv[1]);
	n = (1 << nu);
	dim[0] = dim[1] = n;
	
	/* Create Square array */
	data = (REAL (*)[2])emalloc(2 * n*n*sizeof(REAL));
	copy_of_data = (REAL (*)[2])emalloc(2 * n*n*sizeof(REAL));

	/* Create array of pointers */
	array = (REAL (**)[2])emalloc(n*sizeof(REAL (*)[2]));
	copy_of_array = (REAL (**)[2])emalloc(n*sizeof(REAL (*)[2]));
	for (i = 0; i < n; i++) {
	    array[i] = data+n*i;
	    copy_of_array[i] = copy_of_data+n*i;
	}
	    
	srand((int)time(0));
	
	/* Fill array with random numbers */
	for (i = 0; i < n; i++) {
	    for (j = 0; j < n; j++) {
		array[i][j][0] = (rand() % MAXLONG)/ (double)MAXLONG;
		array[i][j][1] = (rand() % MAXLONG)/ (double)MAXLONG;
	    }
	}

	/* Make a "before" copy */
	for (i = 0; i < n; i++) {
	    for (j = 0; j < n; j++) {
		copy_of_array[i][j][0] = array[i][j][0];
		copy_of_array[i][j][1] = array[i][j][1];
	    }
	}

	/* 
	bcopy(data, copy_of_data, 2 * n * n * sizeof(REAL));
	*/

	fftn(data, 2, dim);
	invfftn(data, 2, dim);
	normalize_fftn(data, 2, dim);

	/* What the heck, treat as a 1-D array */		
	for (i = 0, sum = 0.; i < n*n; i++) { 
		sum += sqr(data[i][0] - copy_of_data[i][0]);
		sum += sqr(data[i][1] - copy_of_data[i][1]);
	}
	
	printf("rms deviation = %7.3e\n", sqrt(sum));
}

